<template>
    <div class="board relative bg-white mr-2 p-2 float-left w-full rounded-lg">
        <div class="heading font-bold text-gray-800 bg-gray-100 h-8 border-b -mt-2 -ml-2 -mr-2 rounded-t-lg pl-2 pt-1">
            <div class="title relative float-left text-pink-500">
                <div class="h-4 w-4 m-auto cursor-pointer inline-block">
                    <img svg-inline class="fill-current inline-block" src="./pix/zond/location.svg" />
                </div>
                <span v-if="loaded">
                    Places of #{{report.id}}
                </span>
            </div>
            <div class="submit relative float-right">
                <button v-if="editable && loaded && !editorOpen" class="text-pink-500 hover:text-pink-700 text-gray-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center" v-on:click="create()">
                    <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/add-solid.svg" />
                    <span>Add</span>
                </button>
                <button class="text-red-500 hover:text-red-700 text-gray-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center" v-on:click="discard()">
                    <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/close-solid.svg" />
                    <span>Cancel</span>
                </button>
            </div>
        </div>
        <div class="body flex flex-row items-stretch content-center w-full">
            <div v-if="!editorOpen && places.length == 0" class="bg-red-200 py-1 px-2 text-sm m-2 border border-red-600 rounded-md w-full my-2 m-auto">
                No Place added to this Spatial report. Please add one manually or 
                <button class="bg-purple-200 text-purple-500 hover:text-purple-700 text-purple-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center" v-on:click="autocode()">
                    <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/location-current.svg" />
                    <span>Locate</span>
                </button>
            </div>
            <div v-else class="align-middle inline-block min-w-full shadow overflow-hidden sm:rounded-lg border-b border-gray-200">
                <table class="min-w-full">
                    <tbody class="bg-white">
                    <tr v-for="p in places" :key="p.id" v-bind:class="{'bg-yellow-200': place && (place.id == p.id), 'hover:bg-gray-100': !place || (place.id != p.id)}">
                        <td class="px-1 whitespace-no-wrap">
                            <div class="flex items-center">
                                <div class="flex-shrink-0 h-8 w-8" v-if="p.type == 'point'">
                                    <img svg-inline src="./pix/point.svg" alt="{{p.type}}" class="w-full h-full" />
                                </div>
                                <div class="flex-shrink-0 h-8 w-8" v-if="p.type == 'circle'">
                                    <img svg-inline src="./pix/circle.svg" alt="{{p.type}}" class="w-full h-full" />
                                </div>
                                <div class="flex-shrink-0 h-8 w-8" v-if="p.type == 'polyline'">
                                    <img svg-inline src="./pix/polyline.svg" alt="{{p.type}}" class="w-full h-full" />
                                </div>
                                <div class="flex-shrink-0 h-8 w-8" v-if="p.type == 'polygon'">
                                    <img svg-inline src="./pix/polygon.svg" alt="{{p.type}}" class="w-full h-full" />
                                </div>
                                <div class="ml-4">
                                    <span class="text-sm leading-5 font-medium text-gray-900 mr-1">{{p.id}}</span>
                                </div>
                            </div>
                        </td>
                        <td class="px-1">
                            <div class="text-sm leading-5 text-gray-900 inline-block float-left mt-1">{{p.title}}</div>
                            <ul class="inline-block ml-2">
                                <li class="list-none float-left mr-1" v-for="(value, key) in p.properties" :key="key" v-if="value.length">
                                    <span class="tag text-xs text-teal-800 inline-block">
                                        <span class="key bg-teal-500 text-teal-100 px-2 rounded-l-full capitalize">{{key}}</span>
                                        <span class="value px-2 -ml-1 bg-teal-300 rounded-r-full">{{value}}</span>
                                    </span>
                                </li>
                            </ul>
                        </td>
                        <td class="px-1 whitespace-no-wrap text-sm leading-5 text-gray-500 text-right">
                            <button class="text-indigo-500 hover:text-indigo-700 bg-transparent font-bold py-2 px-1 rounded inline-flex items-center" v-on:click="search(p)">
                                <img svg-inline src="./pix/zond/search.svg" class="w-4 h-4 fill-current" />
                             </button>
                            <button class="text-indigo-500 hover:text-indigo-700 bg-transparent font-bold py-2 px-1 rounded inline-flex items-center" v-on:click="go(p)">
                                <img svg-inline src="./pix/zond/location.svg" class="w-4 h-4 fill-current" />
                             </button>
                            <button v-if="editable" class="text-teal-500 hover:text-teal-700 bg-transparent font-bold py-2 px-1 rounded inline-flex items-center" v-on:click="update(p)">
                                <img svg-inline src="./pix/zond/edit-pencil.svg" class="w-4 h-4 fill-current" />
                            </button>
                            <button v-if="editable" class="text-red-500 hover:text-red-700 bg-transparent font-bold py-2 px-1 rounded inline-flex items-center" v-on:click="remove(p)">
                                <img svg-inline src="./pix/zond/trash.svg" class="w-4 h-4 fill-current" />
                            </button>
                        </td>
                    </tr>
                    </tbody>
                </table>
            </div>
        </div>
        <div class="body flex flex-row w-full mt-2" v-if="editorOpen">
            <div class="geocoding w-full mr-1">
                <div class="body flex flex-row items-stretch content-center w-full">
                    <v-select v-model="placeType" label="label" :options="types" :reduce="type => type.value" class="w-full bg-gray-100 mb-1"></v-select>
                </div>
                <div class="bg-red-200 py-1 px-2 text-xs m-2 border border-red-600 rounded-md w-full my-2 m-auto" v-if="placeType == 'point' && points.length == 0">
                    Please select exactly one point.
                </div>
                <div class="bg-red-200 py-1 px-2 text-xs m-2 border border-red-600 rounded-md w-full my-2 m-auto" v-if="placeType == 'polyline' && points.length < 2">
                    Please select two or more points.
                </div>
                <div class="body flex flex-row items-stretch content-center w-full">
                    <table class="data-raw table-auto w-full text-xs text-center">
                        <thead>
                            <tr class="border-b">
                                <th class="px-1 py-0">
                                    <button class="text-teal-600 hover:text-teal-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center mr-2" v-on:click="capture()">
                                        <img svg-inline class="fill-current inline-block w-3 h-3" src="./pix/zond/target.svg" />
                                    </button>
                                </th>
                                <th class="px-1 py-0">longitude</th>
                                <th class="px-1 py-0">latitude</th>
                            </tr>
                            <tr class="border-b hover:bg-gray-100" v-for="(l, i) in points"  v-if="points.length > 0">
                                <td class="px-1 py-0">{{i}}</td>
                                <td class="px-1 py-0">{{l.lng}}</td>
                                <td class="px-1 py-0">{{l.lat}}</td>
                            </tr>
                        </thead>
                    </table>
                </div>
                <div class="input flex flex-row justify-end mb-1 bg-gray-Status py-1 px-2 text-sm mt-2">
                    <button class="bg-red-200 text-red-500 hover:text-red-700 text-gray-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center mr-2" v-on:click="clearLocations()">
                        <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/block.svg" />
                        <span>Clear</span>
                    </button>
                    <button v-if="points.length > 0" class="bg-purple-200 text-purple-500 hover:text-purple-700 text-purple-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center" v-on:click="savePlace()">
                        <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/bookmark.svg" />
                        <span>{{place ? 'Update :'+place.id : 'Add'}}</span>
                    </button>
                </div>
            </div>
            <div class="meta w-full border-l ml-2">
                <div class="input flex flex-col items-left mb-1 bg-gray-Status py-1 px-2 text-sm">
                    <label class="mb-1 text-gray-700 font-semibold">Title</label>
                    <input v-model="title" type="text" value="" class="w-full bg-gray-100 h-8 border border-gray-400 rounded-md px-2" />
                </div>
                <div class="input flex flex-col items-left mb-1 bg-gray-Status py-1 px-2 text-sm">
                    <label class="mb-1 text-gray-700 font-semibold">Status</label>
                    <v-select v-model="status" label="label" :options="statuses" :reduce="status => status.value" class="w-full bg-gray-100"></v-select>
                </div>
            </div>
        </div>
        <div v-if="modal" class="absolute left-0 top-0 bg-white opacity-75 w-full h-full flex flex-col">
            <button class="text-pink-500 hover:text-pink-700 text-gray-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center absolute right-0 top-0 mr-2 mt-2" v-on:click="resetModal()">
                <img svg-inline class="fill-current inline-block w-8 h-8" src="./pix/zond/close-outline.svg" />
            </button>
            <div v-if="message" class="w-full m-auto text-center">{{message}}</div>
            <div v-if="saving" class="w-full m-auto text-center">
                <img src="./pix/infinity.gif" class="block relative m-auto" />
                Saving ... 
            </div>
            <div v-if="saved" class="w-full m-auto text-center">
                <img svg-inline class="fill-current w-32 h-32 block m-auto mb-2 text-pink-600" src="./pix/zond/thumbs-up.svg" />
                Saved
            </div>
            <div v-if="removing" class="w-full m-auto text-center">
                <img v-if="removing == 2" src="./pix/infinity.gif" class="block relative m-auto" />
                <span v-if="removing == 2">Removeing Report {{place.id}}</span>
                <span v-if="removing != 2">Remove Report {{place.id}}</span>
                <button v-if="removing != 2" class="text-pink-500 hover:text-pink-700 text-gray-800 font-bold py-1 px-2 text-sm rounded inline-flex items-center" v-on:click="remove(place.id, true)">
                    <img svg-inline class="fill-current inline-block w-4 h-4 mr-2" src="./pix/zond/trash.svg" />
                    <span>Remove</span>
                </button>
            </div>
        </div>
    </div>
</template>
<script>
    import Vue from 'vue'
    import vSelect from 'vue-select'
    import axios from 'axios'
    import axiosCancel from 'axios-cancel';
    import VCalendar from 'v-calendar';
    import {ThemeMixin} from './themes.js';
    
    const DB_WB_DISTRICTS =  [{"value":"AD","label":"Alipurduar"},{"value":"BN","label":"Bankura"},{"value":"BR","label":"Paschim Bardhaman"},{"value":"BR","label":"Purba Bardhaman"},{"value":"BI","label":"Birbhum"},{"value":"KB","label":"Cooch Behar"},{"value":"DA","label":"Darjeeling"},{"value":"UD","label":"Uttar Dinajpur"},{"value":"DD","label":"Dakshin Dinajpur"},{"value":"HG","label":"Hooghly"},{"value":"HR","label":"Howrah"},{"value":"JP","label":"Jalpaiguri"},{"value":"JH","label":"Jhargram"},{"value":"KO","label":"Kolkata"},{"value":"KA","label":"Kalimpong"},{"value":"MA","label":"Malda"},{"value":"ME","label":"Paschim Medinipur"},{"value":"ME","label":"Purba Medinipur"},{"value":"MU","label":"Murshidabad"},{"value":"NA","label":"Nadia"},{"value":"PN","label":"North 24 Parganas"},{"value":"PS","label":"South 24 Parganas"},{"value":"PU","label":"Purulia"}];;
    
    Vue.component('v-select', vSelect);
    Vue.use(VCalendar);

    axiosCancel(axios, {
        debug: false // default
    });
    
    export default {
        name: "WeeSpatialLocationEditor",
        props: {
            editable: {
                type: Boolean,
                default: false
            },
            report: {
                type: Object,
                default: 0
            },
            cancel: {
                type: Function,
                default: function(){}
            }
        },
        mixins: [ThemeMixin],
        data(){
            return {
                loaded: false,
                editorOpen: false,
                place: null,
                types: [
                    {value: 'point',    label: 'Marker'},
                    {value: 'circle',   label: 'Circle'},
                    {value: 'polyline', label: 'Street'},
                    {value: 'polygon',  label: 'Area'}
                ],
                placeType: 'point',
                points: [],
                places: [],
                title: '',
                status: 'active',
                statuses: [{
                    value: 'active',
                    label: 'Active'
                },{
                    value: 'inactive',
                    label: 'Inactive'
                }],
                modal: false,
                saving: false,
                saved: false,
                removing: false,
                removed: false,
                message: null
            }
        },
        created(){
            console.log("created", this.report);
            if(this.report){
                this.loaded = true;
                this.load(this.report);
            }
        },
        watch: {
            report(n, o){
                if(n){
                    this.load();
                    this.loaded = true;
                }else{
                    this.loaded = false;
                }
            },
            place(p, o){
                console.log("watch:place", p, o);
                if(p){
                    this.placeType = p.type;
                    this.title  = p.title;
                    this.status = p.properties.status;
                    if(Array.isArray(p.data)){
                        this.points = p.data;
                    }else{
                        this.points = [p.data];
                    }
                }else{
                    this.clear();
                }
            }
        },
        methods: {
            load(){
                this.clear();
                let self = this;
                axios.get(this.loadUrl).then(function(response){
                    self.places = response.data.places;
                    console.log(self.places);
                });
            },
            create(){
                this.editorOpen = true;
                this.place = null;
            },
            update(p){
                this.go(p);
                this.editorOpen = true;
                this.place = p;
            },
            selected(locations){
                console.log('selected', locations);
                this.points = locations;
            },
            clearLocations(){
                this.points = [];
            },
            clear(){
                this.placeType = 'point';
                this.points = [];
                this.title = "";
                this.place = null;
                this.editorOpen = false;
            },
            discard(){
                this.clear();
                this.cancel();
            },
            addPlace(){
                let self = this;
                this.modal = true;
                this.saving = true;
                let errorf = function(message){
                    self.saving  = false; 
                    self.saved   = false;
                    self.message = message;
                    setTimeout(function(){
                        self.resetModal();
                    }, 1000);
                }
                axios.post(this.locateUrl, {
                    type: this.placeType,
                    title: this.title,
                    data: (this.placeType == 'point' || this.placeType == 'circle') ? {lat: this.points[0].lat, lng: this.points[0].lng} : this.points.map(function(p){return {lat: p.lat, lng: p.lng};}),
                    properties: {
                        status: this.status
                    }
                }).then(function(response){
                    if(response.data.success){
                        self.saving  = false; 
                        self.saved   = true;
                        setTimeout(function(){
                            self.load();
                            self.resetModal();
                        }, 2000);
                        self.$emit('placed', response.data.places[0], self.report.id);
                        console.log("emit placed", response.data.places[0], self.report.id);
                        self.clear();
                    }else{
                        errorf(response.data.message);
                    }
                }).catch(function(error){
                    errorf('Failed to Save');
                    console.log(error);
                });
            },
            updatePlace(){
                let self = this;
                this.modal = true;
                this.saving = true;
                let errorf = function(message){
                    self.saving  = false; 
                    self.saved   = false;
                    self.message = message;
                    setTimeout(function(){
                        self.resetModal();
                    }, 1000);
                }
                axios.post(this.relocateUrl, {
                    type: this.placeType,
                    title: this.title,
                    data: (this.placeType == 'point') ? {lat: this.points[0].lat, lng: this.points[0].lng} : this.points.map(function(p){return {lat: p.lat, lng: p.lng};}),
                    properties: {
                        status: this.status
                    }
                }).then(function(response){
                    if(response.data.success){
                        self.saving  = false; 
                        self.saved   = true;
                        setTimeout(function(){
                            self.load();
                            self.resetModal();
                        }, 2000);
                        console.log(response.data);
                        self.$emit('replaced', self.place.id, self.report.id);
                        console.log("emit replaced", self.place.id, self.report.id);
                        self.clear();
                    }else{
                        errorf(response.data.message);
                    }
                }).catch(function(error){
                    errorf('Failed to Save');
                    console.log(error);
                });
            },
            savePlace(){
                if(this.place){
                    this.updatePlace();
                }else{
                    this.addPlace();
                }
            },
            remove(place, confirm){
                if(!confirm){
                    this.go(place);
                    this.modal = true;
                    this.removing = true;
                    this.place = place;
                }else{
                    let self = this;
                    this.removing = 2;
                    let errorf = function(message){
                        self.removing = false;
                        self.message = message;
                        setTimeout(function(){
                            self.resetModal();
                        }, 1000);
                        self.place = null;
                    }
                    axios.post(this.removeUrl, {}).then(function(response){
                        if(response.data.success){
                            self.removing = false;
                            self.removed  = true;
                            setTimeout(function(){
                                self.load();
                                self.$emit('deplaced', response.data.id, self.report.id);
                                console.log('deplaced', response.data.id, self.report.id);
                                self.resetModal();
                            }, 2000);
                            self.place = null;
                            console.log(response.data);
                        }else{
                            errorf(response.data.message);
                            // TODO Failed to save report
                        }
                    }).catch(function(error){
                        console.log(error);
                        self.place = null;
                    });
                }
            },
            search(place){
                this.$emit('search', place.title);
            },
            go(place){
                this.$emit('go', Array.isArray(place.data) ? place.data[0] : place.data);
            },
            autocode(){
                this.$emit('search', this.report.aoi);
                this.title = this.report.aoi;
                this.capture();
            },
            capture(){
                console.log('this.place', this.place);
                const mode = (this.placeType == 'point' || this.placeType == 'circle') ? 'single' : 'multiple';
                this.$emit('capture', mode, this.place ? this.place.id : 0);
                this.$emit('hide', 1);
            },
            captured(){
                this.$emit('hide', 0);
                this.editorOpen = true;
            },
            resetModal(){
                this.saving = false;
                this.saved = false;
                this.removing = false;
                this.removed = false;
                this.modal = false;
                this.message = null;
            }
        },
        computed: {
            locateUrl(){
                return '/places/locate/'+this.report.id;
            },
            relocateUrl(){
                return '/places/relocate/'+this.place.id;
            },
            removeUrl(){
                return '/places/delocate/'+this.place.id;
            },
            loadUrl(){
                return '/places/of/'+this.report.id;
            }
        }
    }
</script>
<style scoped>

</style>
